@make(ais)
@aiInfo(topic=<Constraint checks and copy-back operations can be interleaved>,
number=[AI-00377/06],
classcode=[ra],
statuscode=[WA],
mainref=[06.04.01@\(07)],
date=[89-06-16])
@aiHeading()
@begin(history)
@begin(toplines)
@mainref()
!class ramification 85-08-22
@cbon()!status WG9-approved 89-06-16@cboff()
@end(toplines)
!status ARG-approved 88-01-30 (reviewed)
!status ARG-approved 88-10-31 (11-0-0) (pending editorial review)
!status work-item 87-03-09
!status received 85-08-22
@references[!references @cbon()@CommentNum[83-00610]83-00610, @CommentNum[83-01265]83-01265]
@topic{!topic Constraint checks and copy-back operations can be interleaved}@cboff()
@end(history)

@subheading[!summary 88-11-20]

For parameters of mode @b[in] @b[out] or @b[out] having a scalar or access
type, constraint checks and copy-back operations may be interleaved in any
order as long as each parameter's constraint is checked at some time before it
is copied back.

@subheading[!question 88-11-20]

6.4(6) says:
@begin(quotation)
Similarly, the language rules do not define in which order  the
values of @b[in] @b[ out] or @b[out]  parameters are copied  back into  the
corresponding actual parameters (when this is done).
@end(quotation)
6.4.1(7) says that for parameters having a scalar or access type, constraint
checks are performed:
@begin(quotation)
After  (normal)  completion  of  the  subprogram  body:  for  a
parameter of mode @b[in] @b[out] or  @b[out], it is checked that the  value
of the formal parameter  belongs to the  subtype of the  actual
variable.  In the case of a  type conversion, the value of  the
formal parameter is converted back and the check applies to the
result of the conversion.
@end(quotation)
Nothing is said about when the constraint checks are performed.  Which one of
the following three alternatives is correct?
@begin(enumerate0)
Each formal parameter is checked just before it is copied back.


All constraint checks are performed before any  copy-back operations
are  performed.


Constraint checks and copy-back  operations may be  interleaved
in any order as long as each parameter's constraint is checked
before it is copied back.
@end(enumerate0)
The answer affects which parameters are copied back before CONSTRAINT_@|ERROR is
raised when one of the constraint checks fails.

@subheading[!response 88-11-20]

The third alternative is the most general and includes the other two as
special cases.  Thus, since the Standard does not define a relative ordering
between constraint check and copy-back operations, the least restrictive
ordering is permitted.  This means constraint checks and copy-back operations
may be interleaved in any order as long as each parameter's constraint is
checked before it is copied back.

The Standard does sometimes specify when checks are to be made relative to
the evaluation of names or expressions (e.g., see 5.2(3)).  The lack of such
a specification in 6.4.1 should be considered intentional.

This uncertainty in when a check is made, and the resulting uncertainty in
what operations have been performed, is not unusual in the language.  In
particular, there are other circumstances when the value of an actual @b[in
out] or @b[out] parameter may or may not have been changed after an exception
has been raised.  For example, since array and record type parameters may be
passed either by copy or by reference, the note in 6.2(12) says:
@begin(quotation)
If the execution of a subprogram is abandoned as a result of an
exception, the final value of an actual parameter of such a type can
be either its value before the call or a value assigned to the formal
parameter during the execution of the subprogram.
@end(quotation)
